#include <errno.h>
#include <unistd.h>
#include <sys/select.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include "myheader.h"
#include "wlanfunc.h"

int wlan_sitesurvey()
{
	unsigned int offset = 0, shift;
	FILE *fp, *tfp;
	unsigned char buffer[MAX_BUFFER_LEN];
	unsigned char *tokenp, *token = ":";
	unsigned char channel;
	char *stop_at;
	
	struct _wlanstruct wlanstruct;
//	memset (wlanstruct, 0, sizeof(wlanstruct));
	
	if ((fp = fopen (SITESURVEY_PATH, "r")) == NULL )
	{
		printf ("Can't find the file(wlan_sitesurvey.inc)\n");
		exit(0);
	}

	if ((tfp = fopen (SITESURVEY_RESULT, "wb")) == NULL)
	{
		printf ("Can't write the file(sitesurvey_result.inc)\n");
		exit(0);
	}

	while (!feof(fp))
	{
        	fgets (buffer, MAX_BUFFER_LEN, fp);
		
                offset = 0;
		if((strstr(buffer, SITESURVEY_STRING)))                              		//NULL: find the string
		{
			memset (wlanstruct.mode, 0, sizeof (wlanstruct.mode));
			memset (wlanstruct.ssid, 0, sizeof (wlanstruct.ssid));
			memset (wlanstruct.channel, 0, sizeof (wlanstruct.channel));
			memset (wlanstruct.wep, 0, sizeof (wlanstruct.wep));
			memset (wlanstruct.state, 0, sizeof (wlanstruct.state));
			memset (wlanstruct.bssid, 0, sizeof (wlanstruct.bssid));
			memcpy (wlanstruct.bssid, (buffer + strlen(buffer) - MAC_LEN + 2), (MAC_LEN - 3));	//BSSID
			
			fgets (buffer, MAX_BUFFER_LEN, fp);
			if (strstr (buffer, "Extra"))
				fgets (buffer, MAX_BUFFER_LEN, fp);
					
			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
                        memcpy (wlanstruct.ssid, (tokenp + 1), (strlen(tokenp) - 3));

			fgets (buffer, MAX_BUFFER_LEN, fp);
			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			*(tokenp + (strlen(tokenp) - 4)) = '\x0a';
			*(tokenp + (strlen(tokenp) - 3)) = '\x0';
			for (shift = 0; shift < strlen(tokenp); shift++)
			{
				if (tokenp[shift] == '.')
				{
					tokenp[shift] = tokenp[shift + 1];
					tokenp[shift + 1] = '.';
				}
			}
			channel = (unsigned char)((strtoul (tokenp, &stop_at, 10) - 2407) / 5);
			if (channel > 13)
				memcpy (wlanstruct.channel, "14", 2);		//CHANNEL
			else if (channel >= 10)	{
				channel -= 10;
				tokenp[0] = 0x31;
				tokenp[1] = 0x30 + channel;
				tokenp[2] = '\x0a';
				tokenp[3] = '\x0';
				memcpy (wlanstruct.channel, tokenp, strlen(tokenp) - 1);		//CHANNEL
			}
			else {
				tokenp[0] = 0x30 + channel;
				tokenp[1] = '\x0a';
				tokenp[2] = '\x0';
				memcpy (wlanstruct.channel, tokenp, strlen(tokenp) - 1);		//CHANNEL
			}
			
			fgets (buffer, MAX_BUFFER_LEN, fp);
			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			if (strstr (tokenp, "Managed"))
				memcpy (wlanstruct.mode, "Infrastructure", 14);
			else
				memcpy (wlanstruct.mode, "Ad-hoc", 6);				//MODE
			
			fgets (buffer, MAX_BUFFER_LEN, fp);
			fgets (buffer, MAX_BUFFER_LEN, fp);

			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			if (tokenp[3] == '/')
			{
				tokenp[3] = '\x0a';
				tokenp[4] = '\x0';
			}
			else if (tokenp[2] == '/')
			{
				tokenp[2] = '\x0a';
				tokenp[3] = '\x0';
			}
			else
			{
				tokenp[1] = '\x0a';
				tokenp[2] = '\x0';
			}
			memcpy (wlanstruct.state, tokenp, (strlen(tokenp) - 1));		//SIGNAL

                        fgets (buffer, MAX_BUFFER_LEN, fp);
			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			memcpy (wlanstruct.wep, tokenp, (strlen(tokenp) - 1));			//WEP

			fwrite (&wlanstruct, sizeof(wlanstruct), 1, tfp);
		}
	}
	fclose (tfp);
	fclose (fp);
	return 0;
}

int wlan_config()
{
	FILE *fp, *tfp;
	unsigned char buffer[MAX_BUFFER_LEN], offset = 0;
	unsigned char *tokenp, *token = ":";
	
	struct _wlanstruct wlanstruct;
	
	if ((fp = fopen (CONFIG_PATH, "r")) == NULL )
	{
		printf ("Can't find the file(wlan_config.inc)\n");
		exit(0);
	}
	if ((tfp = fopen (CONFIG_RESULT, "w")) == NULL)
	{
		printf ("Can't write the file(wlanresult.inc)\n");
		exit(0);
	}
	
	memset (&wlanstruct, 0, sizeof(wlanstruct));
	while (!feof(fp))
	{
		fgets (buffer, MAX_BUFFER_LEN, fp);
		if ( (strstr (buffer, CONFIG_STRING)))
		{
			memset (&wlanstruct, 0, sizeof(wlanstruct));

			tokenp = strtok (buffer, token);
			if (strstr (tokenp, "802.11-g"))
			{
				strcpy (wlanstruct.state, "Connect");
				wlanstruct.state[strlen(wlanstruct.state) + 1] = '\x0';
				wlanstruct.state[strlen(wlanstruct.state)] = '\x0a';
			}
			else
				break;
			
			tokenp = strtok (NULL, token);
                       	while ( *(tokenp + 1 + offset) != '"')
				offset++;
			*(tokenp + offset + 1) = '\x0a';
                       	*(tokenp + offset + 2 ) = '\x0';
			strcpy (wlanstruct.ssid, tokenp + 1);

			fgets (buffer, MAX_BUFFER_LEN, fp);
			strcpy (wlanstruct.bssid, buffer + strlen(buffer) - MAC_LEN);

			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			if (strstr (tokenp, "Managed"))
				strcpy (wlanstruct.mode, "Infrastructure");
			else
				strcpy (wlanstruct.mode, "Ad-hoc");
			
			wlanstruct.mode[strlen(wlanstruct.mode) + 1] = '\x0';
			wlanstruct.mode[strlen(wlanstruct.mode) ] = '\x0a';
							       
			tokenp = strtok (NULL, token);
			if (*(tokenp + 1) == '\x20')
			{
			       	*(tokenp + 1) = '\x0a';
        	                *(tokenp + 2) = '\x0';
			}
			else
			{
				*(tokenp + 2) = '\x0a';
				*(tokenp + 3) = '\x0';
			}
			strcpy (wlanstruct.channel, tokenp);

			fgets (buffer, MAX_BUFFER_LEN, fp);
			fgets (buffer, MAX_BUFFER_LEN, fp);
			fgets (buffer, MAX_BUFFER_LEN, fp);
			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			strcpy (wlanstruct.wep, tokenp);
		}
	}
    
	 if ( !strlen (wlanstruct.mode) )
        {
                fputs ("MODE=Unknown\n", tfp);
                fputs ("ESSID=Unknown\n", tfp);
                fputs ("CHANNEL=Unknown\n", tfp);
                fputs ("WEP=Unknown\n", tfp);
                fputs ("STATE=Disconnected\n", tfp);
                fputs ("BSSID=Unknown\n", tfp);
        }

	else
	{
		sprintf (buffer, "MODE=%s", wlanstruct.mode);
		fputs (buffer, tfp);
		sprintf (buffer, "ESSID=%s", wlanstruct.ssid);
		fputs (buffer, tfp);
		sprintf (buffer, "CHANNEL=%s", wlanstruct.channel);
		fputs (buffer, tfp);
		sprintf (buffer, "WEP=%s", wlanstruct.wep);
		fputs (buffer, tfp);
		sprintf (buffer, "STATE=%s", wlanstruct.state);
		fputs (buffer, tfp);
		sprintf (buffer, "BSSID=%s", wlanstruct.bssid);
		fputs (buffer, tfp);
	}
	
	fclose (tfp);
        fclose (fp);	
	return 0;
}
/*
void wlan_start()
{
	unsigned char buffer[MAX_BUFFER_LEN];
	FILE *fp;
	
	system ("flash get WIRELESS_FUNCTION > /tmp/wlanfunction.inc");
	system ("cat /dev/lanSt >> /tmp/wlanfunction.inc");
	system ("/bin/flash get HW_NIC0_ADDR >> /tmp/wlanfunction.inc");
	system ("/bin/flash get AP_MODE >> /tmp/wlanfunction.inc");
	system ("/bin/flash get CHANNEL >> /tmp/wlanfunction.inc");
	system ("/bin/flash get SSID >> /tmp/wlanfunction.inc");
	system ("/bin/flash get WEP >> /tmp/wlanfunction.inc");					//WEP
	system ("/bin/flash get WEP_DEFAULT_KEY >> /tmp/wlanfunction.inc");
	system ("/bin/flash get IP_ADDR >> /tmp/wlanfunction.inc");
	system ("/bin/flash get SUBNET_MASK >> /tmp/wlanfunction.inc");
	 		
	if ((fp = fopen ("/tmp/wlanfunction.inc", "r")) == NULL)
		exit(0);
	
	fgets (buffer, MAX_BUFFER_LEN, fp);
	buffer[strlen(buffer) - 1] = '\x0';
	fclose (fp);

	if ( !memcmp(buffer, "WIRELESS_FUNCTION=2", 19))				//AUTO
	{
		if ((fp = fopen ("/tmp/wlanfunction.inc", "r")) == NULL)
			exit(0);

		fgets (buffer, MAX_BUFFER_LEN, fp);
		fgets (buffer, MAX_BUFFER_LEN, fp);
		buffer[strlen(buffer) - 1] = '\x0';
		fclose (fp);
		if ( !strcmp(buffer, "0"))
		{
			wlanstart();
			system ("echo led blink 250 > /dev/led_wlan");
		}
		else 
			system ("ifconfig eth1 > /dev/urandom");
	}
	else if ( !memcmp (buffer, "WIRELESS_FUNCTION=1", 19))				//WIRELESS
	{
		wlanstart();
		system ("echo led blink 250 > /dev/led_wlan");
	}

	else 
		system ("ifconfig eth1 > /dev/urandom");

	exit(0);
}

void wlanstart()
{
	unsigned char buffer[MAX_BUFFER_LEN], command[MAX_BUFFER_LEN];
	unsigned char *tokenp, *token="=";
	FILE *fp, *wepfp;
			
	fp = fopen ("/tmp/wlanfunction.inc", "r");
	
	fgets (buffer, MAX_BUFFER_LEN, fp);						//set mac address
	fgets (buffer, MAX_BUFFER_LEN, fp);
	fgets (buffer, MAX_BUFFER_LEN, fp);
	tokenp = strtok (buffer, token);
	tokenp = strtok (NULL, token);
	sprintf (command, "/sbin/ifconfig wlan0 hw ether %s", tokenp);
	system (command);
	
	fgets (buffer, MAX_BUFFER_LEN, fp);						//if (ad-hoc) set mode and channel
	if ( !memcmp(buffer, "AP_MODE=1", 9))					//if (ad-hoc) set mode and channel
	{
		system ("/sbin/iwconfig wlan0 mode ad-hoc");
		sleep(1);
	}
	
	fgets (buffer, MAX_BUFFER_LEN, fp);
	tokenp = strtok (buffer, token);
	tokenp = strtok (NULL, token);
	sprintf (command, "/sbin/iwconfig wlan0 channel %s", tokenp);
	system (command);
	sleep(1);
//	else
//		fgets (buffer, MAX_BUFFER_LEN, fp);

        fgets (buffer, MAX_BUFFER_LEN, fp);                                             //set SSID
        tokenp = strtok (buffer, token);
        tokenp = strtok (NULL, token);
        *(tokenp + strlen(tokenp) - 2) = '\x0a';
        *(tokenp + strlen(tokenp) - 1) = '\x0';

        if ( memcmp ((tokenp + 1), "default", 7))
        {
                sprintf (command, "/sbin/iwconfig wlan0 essid %s", (tokenp + 1));
                system (command);
        }
	
	fgets (buffer, MAX_BUFFER_LEN, fp);					
	if (!memcmp (buffer, "WEP=0", 5))
	{
		fgets (buffer, MAX_BUFFER_LEN, fp);
	}
	else
	{
		if (!memcmp (buffer, "WEP=1", 5))
		{
			fgets (buffer, MAX_BUFFER_LEN, fp);
			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			*tokenp += 0x01;
			*(tokenp + 1) = '\x0';
			sprintf (command, "/bin/flash get WEP64_KEY%s > /tmp/weptmp.inc", tokenp);
			system (command);
		}
		else
		{
        	        fgets (buffer, MAX_BUFFER_LEN, fp);
			tokenp = strtok (buffer, token);
			tokenp = strtok (NULL, token);
			*(tokenp + 1) = '\x0';
			*tokenp += 0x01;
			sprintf (command, "/bin/flash get WEP128_KEY%s > /tmp/weptmp.inc", tokenp);
			system (command);
		}
		
		if ((wepfp = fopen ("/tmp/weptmp.inc", "r")) == NULL)
			exit(0);
		fgets (buffer, MAX_BUFFER_LEN, wepfp);
		tokenp = strtok (buffer, token);
		tokenp = strtok (NULL, token);
		sprintf (command, "/sbin/iwconfig wlan0 key %s", tokenp);
		system (command);
		fclose (wepfp);
	}
	
	system ("/sbin/ifconfig wlan0 up");
	
	fgets (buffer, MAX_BUFFER_LEN, fp);						//set ip address
	tokenp = strtok (buffer, token);
	tokenp = strtok (NULL, token);
	*(tokenp + strlen(tokenp) - 2) = '\x0a';
	*(tokenp + strlen(tokenp) - 1) = '\x0';
	sprintf (command, "/sbin/ifconfig wlan0 %s", (tokenp + 1));
	system (command);

	fgets (buffer, MAX_BUFFER_LEN, fp);						//set netmask
	tokenp = strtok (buffer, token);
	tokenp = strtok (NULL, token);
	*(tokenp + strlen(tokenp) - 2) = '\x0a';
	*(tokenp + strlen(tokenp) - 1) = '\x0';
	sprintf (command, "/sbin/ifconfig wlan0 netmask %s", (tokenp + 1));
	system (command);
	
	system ("/sbin/ifconfig eth1 down");
	system ("/sbin/ifconfig wlna0 > /dev/urandom");
	
	fclose (fp);
}
*/
